#!/usr/bin/python
#
# Copyright (C) 2006 by Jose Manuel Ferrer Mosteiro <jmferrer@di.uc3m.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import gtk
import gtk.glade
import os 
import re
#import select
#import gobject
import time

APP_DIR="/usr/share/geduroam"
CONF_FILE="/etc/wpa_supplicant.conf"

class geduroam:
	def __init__(self):
		if os.getuid() != 0:
			print "Debe ser root para ejecutar esta aplicacion."
		else:
			# Import the Glade GUI
			self.xml = gtk.glade.XML(APP_DIR+"/geduroam.glade")
			# Connect all the signals
			self.xml.signal_autoconnect(self)
			
			# globals
			self.drivers = []
			self.interfaces = []
			
			# set driver_combobox_entry
			self.set_driver_combobox_entry(self.xml.get_widget("driver_comboboxentry"))
			self.set_wlan_comboboxentry (self.xml.get_widget("wlan_comboboxentry"))
			
			gtk.main()

	########################################################################
	# Funciones de finalizacin en la pantalla principal (geduroam_window) #
	########################################################################
	def gtk_main_quit(self,widget):
		gtk.main_quit()
	
	def on_cerrar_button_clicked(self,widget):
		self.gtk_main_quit(widget)
		
	def on_quit_activate (self, widget):
		self.gtk_main_quit(widget)
		
	def on_geduroam_window_destroy (self,widget):
		self.gtk_main_quit(self)

	#################################################################################
	# Mtodos para rellenar el desplegable de los drivers que acepta wpa_supplicant #
	#################################################################################

	def set_driver_combobox_entry (self, driver_comboboxentry):
		drivers = self.get_drivers()
		for driver in drivers:
			driver_comboboxentry.append_text(driver)
		
	def get_drivers (self):
		salida=os.popen ("wpa_supplicant -h",'r')
		driver=0;
		drivers=[]
		for line in salida:
			if driver==0:
				if line.startswith("drivers:"):
					driver=1;
			else:
				if line.startswith('options:'):
					driver=0;
				else:
					# Quitamos el retorno de carro
					line = line[:-1]
					drivers.append(line)
		return drivers


	###########################################################################
	# Mtodos para rellenar el desplegable de la interfaz de red inhalmbrica #
	###########################################################################

	def set_wlan_comboboxentry (self, wlan_comboboxentry):
		interfaces=self.get_wireless_interfaces()
		for interfaz in interfaces:
			wlan_comboboxentry.append_text(interfaz)

	def get_wireless_interfaces(self):
		interfaces=[]
		salida=os.popen("iwconfig",'r')
		for line in salida:
			if (line[0]!=" ") and (len(line) > 2):
				if line [10:33]!="no wireless extensions.":
					interfaces.append(line.split()[0])
		return interfaces
	
	
	####################################################################
	# Mtodos para configurar la eduroam al pulsar el botn "conectar" #
	####################################################################
	
	def on_conectar_button_clicked (self, widget):
		login = self.xml.get_widget('email_entry').get_text()
		password = self.xml.get_widget('password_entry').get_text()
		wlan = self.xml.get_widget('wlan_comboboxentry').get_active_text()
		driver = self.xml.get_widget('driver_comboboxentry').get_active_text().split()[0]
		
		self.init_configuration_wpa_supplicant (login, password)
		
		os.system ("ifconfig " + wlan + " up")
		os.system ("wpa_supplicant -B -i " + wlan + " -c /etc/wpa_supplicant.conf -dd -D " + driver)
		time.sleep (5)
		os.system ("dhclient " + wlan)
		
		
# ifconfig mi-interfaz-wifi up
# wpa_supplicant -B -i mi-interfaz-wifi -c /etc/wpa_supplicant.conf -dd -D mi-driver
# sleep 5
# dhclient mi-interfaz-wifi

		
	def init_configuration_wpa_supplicant (self, login, password):
		configuration_file = file(CONF_FILE,"w")
#		configuration_file.write("timeout 8\n")
		configuration_file.write("ctrl_interface=/var/run/wpa_supplicant\n")
		configuration_file.write("ctrl_interface_group=0\n")
		configuration_file.write("eapol_version=1\n")
		configuration_file.write("ap_scan=1\n")
		configuration_file.write("fast_reauth=1\n")
		configuration_file.write("network={\n")
		configuration_file.write("ssid=\"eduroam\"\n")
		configuration_file.write("key_mgmt=WPA-EAP\n")
		configuration_file.write("eap=TTLS\n")
		configuration_file.write("anonymous_identity=\"anonymous\"\n")
		configuration_file.write("identity=\""+login+"\"\n")
		configuration_file.write("password=\""+password+"\"\n")
		configuration_file.write("priority=2\n")
		configuration_file.write("phase2=\"auth=PAP\"\n")
		configuration_file.write("ca_cert=\"/etc/cert/iris-pca.cader.crt\"\n")
		configuration_file.write("}\n")
		configuration_file.close()


if __name__=='__main__': app = geduroam()

